

class Service
{
    constructor(name) {
        console.log('constructing Service...');
        this.name =  name;
        this.endpoints = [];
        this.patterns = [];
    }

    endpoint(ep) {
        ep.setHandler((req, res) => {
            this.processMessage(req, res);
        });

        this.endpoints.push(ep);
        return this;
    }

    processMessage(msg, reply) {
        var pattern = this.findPattern(msg);
        if (pattern) {
            console.log('found pattern: ', pattern);

            pattern.callback(msg, reply);
        } else {
            console.log('did not find pattern forn msg: ', msg);
        }
    }

    command(pattern, callback){
        this.patterns.push({
           pattern: pattern,
           callback: callback
        });
        return this;
    }

    findPattern(pattern) {

        var found = this.patterns.find(pat => {

            var keys = Object.keys(pat.pattern);
            for(var i = 0; i < keys.length; i++)
            {
                var key = keys[i];
                if (!pattern.hasOwnProperty(key))
                {
                    return false;
                }

                if (pattern[key] != pat.pattern[key])
                {
                    return false;
                }
            }
            return true;
        });
        return found;
    }

    client() {
        return {
            command: (cmd) => {
                var pattern = this.findPattern(cmd);
                if (pattern) {
                    pattern.callback();
                }
            }
        };
    }

    listen(done) {
        this.endpoints.forEach(endpoint => {
            endpoint.listen().then(done);
        })
        return this;
    }

    stop() {
        this.endpoints.forEach(endpoint => endpoint.stop());
    }
};

module.exports = (name) => new Service(name);