var expect = require('chai').expect;

var service = require('./service');
var client = require('./client');

class Endpoint
{
    constructor(name) {
        this.name = name;
    }

};

var connections = [];

function test_endpoint(name) {
    var ep = {
        name: name,
        setHandler: function (handler) {
        }
    };
    connections.push(ep);
    return ep;
}

describe('service', () => {

    describe('with test-service', () => {
        it('has name test-service', () => {

            var svc = service('test-service');
            expect(svc.name).to.be.equal('test-service');
        });

        describe('with test_endpoint', () => {

            it('has endpoint with rest name', () => {
                var svc = service('test-service')
                    .endpoint(test_endpoint('rest'));

                expect(svc.endpoints[0].name).to.be.equal('rest');
            });


            describe('with test command', () => {
                it('client command calls service callbacl', (done) => {

                    var svc = service('test-service')
                        .endpoint(test_endpoint('rest'))
                        .command({cmd: 'test'}, (msg, reply) => {
                            console.log('cmd=test called...');
                            done();
                        });

                    var client = svc.client();

                    client.command({cmd: 'test'});
                });
            });
        });
    });
});