var express = require('express');
var bodyParser     =        require("body-parser");


class ExpressEndpoint
{
    constructor(name, options) {
        this.name = name;
        this.options = options;
        this.app = express();
        this.app.use(bodyParser.json());
    }

    setHandler(handler) {
        this.options.handler = handler;
    }
    listen() {

        this.app.get('/api', (req, res) => {
            console.log('get req...');
            this.options.handler(req.query, (response) => {
                res.json(response);
            });
        });

        this.app.post('/api', (req, res) => {
           var msg = Object.assign({}, req.query, req.body);
           console.log('post msg: ', msg);
            this.options.handler(msg, (response) => {
                res.json(response);
            });
        });

        return new Promise((resolve, reject) => {
            this.server = this.app.listen(this.options.port, () => {
                console.log('listening on port: ', this.options.port);
                resolve();
            });
        });
    }

    stop() {
        this.server.close();
    }
};

module.exports = (name, options) => new ExpressEndpoint(name, options);