var expect = require('chai').expect;

var express = require('../lib/transports/express');
var service = require('../lib/service');


var request = require('superagent');

describe('service with express endpoint', () => {
    var svc;

    beforeEach((done) => {
        svc = service('express-service')
            .endpoint(express('express', {
                port: 9201,
                method: 'GET'
            }))
            .command({cmd: 'test'}, (msg,reply) => {
                console.log('cmd test...');
                reply({response: 'test'});
            })
            .listen(done);
    });

    afterEach(() => {
       svc.stop();
    });

    it('test', (done) => {
       console.log('test test');

       request.get('http://localhost:9201/api?cmd=test')
           .end((err,res) => {
               console.log('err: ', err);
                console.log('res: ', res.body);
                if (res.body.response === 'test') {
                    done();
                } else {
                    done(new  Error('invalid response: ', res.body));
                }

           });
    });


});



